diff --git a/vhdlparser/vhdlparser.jj b/vhdlparser/vhdlparser.jj
index fbae037..7611dd9 100644
--- a/vhdlparser/vhdlparser.jj
+++ b/vhdlparser/vhdlparser.jj
@@ -1512,12 +1518,12 @@ QCString library_clause() :  {QCString s;}
                    {
                            addVhdlType(s.data(),getLine(),Entry::VARIABLE_SEC,VhdlDocGen::LIBRARY,s.data(),"_library_",Public);
                    }
-                   QCString s1="library "+s;
+                   VhdlString s1="library "+s;
                    return s1;
  }
 }
 
-QCString library_unit() :  {QCString s;}
+VhdlString library_unit() :  {VhdlString s;}
 {
 LOOKAHEAD(2)
 primary_unit() {  return s; }
@@ -1526,7 +1532,7 @@ primary_unit() {  return s; }
 
 }
 
-QCString literal() :  {QCString s;}
+VhdlString literal() :  {VhdlString s;}
 {
 
  LOOKAHEAD(bit_string_literal())
@@ -1542,12 +1548,12 @@ s=enumeration_literal() { return s;}
 | <NULL_T> {return "null";}
 }
 
-QCString logical_operator() :  {QCString s;}
+VhdlString logical_operator() :  {VhdlString s;}
 {
  s=logop() { return s;}
 }
 
-QCString loop_statement() :  {QCString s,s1,s2,s3;}
+VhdlString loop_statement() :  {VhdlString s,s1,s2,s3;}
 {
 [ s=identifier() <COLON_T> {s+=":";} ]
     [ s1=iteration_scheme()  ]
@@ -1559,8 +1565,8 @@ QCString loop_statement() :  {QCString s,s1,s2,s3;}
         s2=sequence_of_statement()
         <END_T> <LOOP_T> [ s3=identifier() ] <SEMI_T>
         {
-         QCString q = s+" loop "+s2+" end loop" +s3;
-         QCString endLoop="end loop" + s3;
+         VhdlString q = s+" loop "+s2+" end loop" +s3;
+         VhdlString endLoop="end loop" + s3;
          FlowChart::moveToPrevLevel();
          FlowChart::addFlowChart(FlowChart::END_LOOP,endLoop.data(),0);
         return q;
@@ -1569,14 +1575,14 @@ QCString loop_statement() :  {QCString s,s1,s2,s3;}
 }
 
 
-QCString miscellaneous_operator():{Token *t=0;}
+VhdlString miscellaneous_operator():{Token *t=0;}
 {
   <DOUBLEMULT_T> {return "**";}
   | <ABS_T>  {return "abs";}
   | <NOT_T> {return "not";}
 }
 
-QCString mode() :  {Token *tok=0;}
+VhdlString mode() :  {Token *tok=0;}
 {
 tok=<IN_T> { return "in"; }
 | tok=<OUT_T> { return "out"; }
@@ -1585,7 +1591,7 @@ tok=<IN_T> { return "in"; }
 | tok=<LINKAGE_T> { return "linkage"; }
 }
 
-QCString multiplying_operation() : {Token *tok=0;}
+VhdlString multiplying_operation() : {Token *tok=0;}
 {
 tok=<MULT_T>      { return tok->image.c_str(); }
 | tok=<SLASH_T>  { return tok->image.c_str(); }
@@ -1594,7 +1600,7 @@ tok=<MULT_T>      { return tok->image.c_str(); }
 }
 
 
- QCString name() :  {QCString s,s1;}
+ VhdlString name() :  {VhdlString s,s1;}
 {
  (
    s=operator_symbol()
@@ -1603,12 +1609,12 @@ tok=<MULT_T>      { return tok->image.c_str(); }
  [LOOKAHEAD(name_ext1()) s1=name_ext1(){ s+=s1;}] {  return s; }
 }
 
-QCString name_ext1() : {QCString s,s1,s2;}
+VhdlString name_ext1() : {VhdlString s,s1,s2;}
  {
    s=name_ext() (LOOKAHEAD(name_ext()) s1=name_ext(){s+=s1;})* { return s;}
  }
 
- QCString name_ext() : {QCString s,s1,s2;}
+ VhdlString name_ext() : {VhdlString s,s1,s2;}
  {
 
   (
@@ -1628,7 +1634,7 @@ QCString name_ext1() : {QCString s,s1,s2;}
  {return s;}
  }
 
- QCString test_att_name() : {QCString s,s1;}
+ VhdlString test_att_name() : {VhdlString s,s1;}
  {
   [ LOOKAHEAD(<LBRACKET_T>) s1=signature() {s=s1;}]
   <APOSTROPHE_T> s1=attribute_designator() {s+="'";s+=s1;}
@@ -1636,12 +1642,12 @@ QCString name_ext1() : {QCString s,s1,s2;}
    { return s;}
  }
 
- QCString indexed_name() : {QCString s,s1,s2;}
+ VhdlString indexed_name() : {VhdlString s,s1,s2;}
  {
    s2=identifier() <LPAREN_T> s1=expression(){s=s2+"("+s1;} (<COMMA_T> s1=expression(){s+=",";s+=s1;})* <RPAREN_T> {return s+")";}
  }
 
-QCString next_statement() :  {QCString s,s1,s2;Token *t=0;Token *t1=0;}
+VhdlString next_statement() :  {VhdlString s,s1,s2;Token *t=0;Token *t1=0;}
 {
 [LOOKAHEAD(1) s=identifier() t=<COLON_T> ] <NEXT_T> [ s1=identifier() ]
 [LOOKAHEAD(1)  t1=<WHEN_T> s2=condition() ] <SEMI_T>
@@ -1654,12 +1660,12 @@ QCString next_statement() :  {QCString s,s1,s2;Token *t=0;Token *t1=0;}
 }
 }
 
-QCString null_statement() : {QCString s;}
+VhdlString null_statement() : {VhdlString s;}
 {
 [ s=identifier() <COLON_T> {s+=":";}] <NULL_T> <SEMI_T>{return s+="null";}
 }
 
-QCString numeric_literal() :  {QCString s;}
+VhdlString numeric_literal() :  {VhdlString s;}
 {
 
  LOOKAHEAD(physical_literal())
@@ -1667,7 +1673,7 @@ QCString numeric_literal() :  {QCString s;}
  | s=abstract_literal() { return s;}
 }
 
-QCString object_class() :  {}
+VhdlString object_class() :  {}
 {
 <CONSTANT_T>          { return "constant"; }
 |<SIGNAL_T>            { return "signal"; }
@@ -1677,7 +1683,7 @@ QCString object_class() :  {}
 |<TYPE_T>              { return "type"; }
 }
 
-QCString operator_symbol() :  {Token *tok=0;}
+VhdlString operator_symbol() :  {Token *tok=0;}
 {
 tok=<STRINGLITERAL> {return tok->image.c_str();}
 }
@@ -1687,13 +1693,13 @@ void options() :  {}
   [ <GUARDED_T> ] [ delay_mechanism() ]
 }
 
-void package_body() :  {QCString s;}
+void package_body() :  {VhdlString s;}
 {
 <PACKAGE_T> <BODY_T> s=name() <IS_T>
  {
                         lastCompound=current;
                         s.prepend("_");
-                        addVhdlType(s,getLine(),Entry::CLASS_SEC,VhdlDocGen::PACKAGE_BODY,0,0,Protected);
+                        addVhdlType(s.data(),getLine(),Entry::CLASS_SEC,VhdlDocGen::PACKAGE_BODY,0,0,Protected);
                       }
  package_body_declarative_part()
 
@@ -1722,7 +1728,7 @@ void package_body_declarative_part() :  {}
 (package_body_declarative_item() )*
 }
 
-void package_declaration():  {QCString s;}
+void package_declaration():  {VhdlString s;}
 {
 
  <PACKAGE_T> s=identifier() <IS_T>
@@ -1731,12 +1737,12 @@ void package_declaration():  {QCString s;}
                           Entry *clone=new Entry(*current);
                           clone->section=Entry::NAMESPACE_SEC;
                           clone->spec=VhdlDocGen::PACKAGE;
-                          clone->name=s;
+                          clone->name=s.data();
                           clone->startLine=getLine(PACKAGE_T);
                           clone->bodyLine=getLine(PACKAGE_T);
                           clone->protection=Package;
                           current_root->addSubEntry(clone);
-                          addVhdlType(s,getLine(PACKAGE_T),Entry::CLASS_SEC,VhdlDocGen::PACKAGE,0,0,Package);
+                          addVhdlType(s.data(),getLine(PACKAGE_T),Entry::CLASS_SEC,VhdlDocGen::PACKAGE,0,0,Package);
                           }
     package_declarative_part()
 <END_T> [ <PACKAGE_T>] [ name() ] <SEMI_T>
@@ -1783,17 +1789,17 @@ void package_declarative_part() : {}
  (package_declarative_item())*
 }
 
-QCString parameter_specification() : {QCString s,s1;}
+VhdlString parameter_specification() : {VhdlString s,s1;}
 {
 s=identifier() <IN_T> s1=discrete_range(){ return s+" in "+s1;}
 }
 
-QCString physical_literal() :  {QCString s,s1;}
+VhdlString physical_literal() :  {VhdlString s,s1;}
 {
  [LOOKAHEAD(abstract_literal()) s=abstract_literal()] s1=name(){s+=" ";s+=s1;s.prepend(" "); return s;}
 }
 
-QCString physical_type_definition() : {QCString s,s1,s2;}
+VhdlString physical_type_definition() : {VhdlString s,s1,s2;}
 {
         <UNITS_T>
             s=identifier()<SEMI_T> { addVhdlType(s.data(),getLine(),Entry::VARIABLE_SEC,VhdlDocGen::UNITS,0,0,Public);}
@@ -1810,7 +1816,7 @@ void port_clause() :  {}
    <PORT_T> <LPAREN_T>  port_list()<RPAREN_T>  <SEMI_T>{ currP=0; }
 }
 
-QCString port_list() : {QCString s;}
+VhdlString port_list() : {VhdlString s;}
 {
   s=interface_list(){return s;}
 }
@@ -1820,7 +1826,7 @@ void port_map_aspect() : {}
  <PORT_T> <MAP_T> <LPAREN_T> association_list() <RPAREN_T>
 }
 
-QCString primary() : {QCString s,s1;}
+VhdlString primary() : {VhdlString s,s1;}
 {
 LOOKAHEAD(function_call())
 s=function_call() { return s;}
@@ -1860,13 +1866,13 @@ LOOKAHEAD(4)
 
 }
 
-QCString procedure_call() : {QCString s,s1;}
+VhdlString procedure_call() : {VhdlString s,s1;}
 {
  s=name()  [ <LPAREN_T> s1=actual_parameter_part() <RPAREN_T>{ s1.prepend("("); s1.append(")");}]
 { return s+s1;}
  }
 
-QCString procedure_call_statement() :  {QCString s,s1;}
+VhdlString procedure_call_statement() :  {VhdlString s,s1;}
 {
 [LOOKAHEAD(2) s=identifier() <COLON_T> { s+=":"; }] s1=procedure_call() <SEMI_T>
 {
@@ -1874,7 +1880,7 @@ QCString procedure_call_statement() :  {QCString s,s1;}
 }
 }
 
-QCString process_declarative_item() :  {QCString s;}
+VhdlString process_declarative_item() :  {VhdlString s;}
 {
 subprogram_declaration() { return "";}
 //| subprogram_body()
@@ -1895,12 +1901,12 @@ s=group_template_declaration()  { return s;}
 | s=group_declaration() { return s;}
 }
 
-QCString process_declarative_part() :{QCString s,s1;}
+VhdlString process_declarative_part() :{VhdlString s,s1;}
 {
  ( s1=process_declarative_item(){s+=s1;} )* { return s;}
 }
 
-void process_statement() : {QCString s,s1,s2;Token *tok=0;}
+void process_statement() : {VhdlString s,s1,s2;Token *tok=0;}
 {
 [ s=identifier() <COLON_T> ]
 [ <POSTPONED_T> ]
@@ -1929,13 +1935,13 @@ void process_statement() : {QCString s,s1,s2;Token *tok=0;}
    else
    currName=s;
 
-   current->name=currName;
+   current->name=currName.data();
    tempEntry=current;
    current->endBodyLine=getLine();
    currP=0;
  if(tok)
    s1=tok->image.data();
-  createFunction(currName,VhdlDocGen::PROCESS,s1.data());
+  createFunction(currName.data(),VhdlDocGen::PROCESS,s1.data());
   createFlow();
    currName="";
    newEntry();
@@ -1947,7 +1953,7 @@ void process_statement_part() :  {}
   (sequential_statement())*
 }
 
-QCString qualified_expression() :  {QCString s,s1;}
+VhdlString qualified_expression() :  {VhdlString s,s1;}
 {
   s1=identifier() <APOSTROPHE_T> {s=s1+"'";}
   (
@@ -1958,7 +1964,7 @@ QCString qualified_expression() :  {QCString s,s1;}
  {return s;}
 }
 
-QCString range() :  {QCString s,s1,s2;}
+VhdlString range() :  {VhdlString s,s1,s2;}
 {
    LOOKAHEAD( simple_expression() direction() simple_expression())
    s=simple_expression() s1=direction() s2=simple_expression(){return s+" "+s1+" "+s2;}
@@ -1967,7 +1973,7 @@ QCString range() :  {QCString s,s1,s2;}
   s=attribute_name(){ return s;}
 }
 
-QCString range_constraint() :  {QCString s,s1;}
+VhdlString range_constraint() :  {VhdlString s,s1;}
 {
 <RANGE_T> s=range(){return " range "+s;}
 }
@@ -1982,12 +1988,12 @@ void record_type_definition() : {}
        <RECORD_T> [ name()]
 }
 
-QCString relation() :  {QCString s,s1,s2;}
+VhdlString relation() :  {VhdlString s,s1,s2;}
 {
   s=shift_expression() [LOOKAHEAD(1) s1=relation_operator() s2=shift_expression() ] {return s+s1+s2;}
 }
 
-QCString relation_operator() :  {}
+VhdlString relation_operator() :  {}
 {
  <LT_T> {return "<";}
  |<GT_T> {return ">";}
@@ -1998,7 +2004,7 @@ QCString relation_operator() :  {}
 
 }
 
-QCString report_statement() :  {Token *t=0;Token *t1=0;QCString s,s1,s2;}
+VhdlString report_statement() :  {Token *t=0;Token *t1=0;VhdlString s,s1,s2;}
 {
 [ s=identifier() t=<COLON_T> ]
     <REPORT_T> s1=expression()
@@ -2011,13 +2017,13 @@ QCString report_statement() :  {Token *t=0;Token *t1=0;QCString s,s1,s2;}
         }
 }
 
-QCString return_statement() :  {QCString s,s1;}
+VhdlString return_statement() :  {VhdlString s,s1;}
 {
 [ s=identifier() <COLON_T> { s+=":";}] <RETURN_T> [ s1=expression() ] <SEMI_T>
 { return s+" return "+s1+";";}
 }
 
-QCString scalar_type_definition() : {QCString s,s1;}
+VhdlString scalar_type_definition() : {VhdlString s,s1;}
 {
 
 s=enumeration_type_definition(){ return s;}
@@ -2030,7 +2036,7 @@ architecture_body()
 | package_body()
 }
 
-QCString secondary_unit_declaration() :  {QCString s,s1;}
+VhdlString secondary_unit_declaration() :  {VhdlString s,s1;}
 {
 s=identifier() <EQU_T> s1=physical_literal() <SEMI_T>
 {
@@ -2040,7 +2046,7 @@ s=identifier() <EQU_T> s1=physical_literal() <SEMI_T>
   return s+"="+s1; }
 }
 
-QCString selected_name() : {QCString s,s1;}
+VhdlString selected_name() : {VhdlString s,s1;}
 {
  s=identifier() <DOT_T> s1=suffix(){ return s+"."+s1;}
 }
@@ -2057,7 +2063,7 @@ void selected_waveforms() :  {}
  waveform() <WHEN_T> choices()(<COMMA_T> waveform() <WHEN_T> choices())*
 }
 
-QCString sensitivity_clause() :  {QCString s;}
+VhdlString sensitivity_clause() :  {VhdlString s;}
 {
  <ON_T> s=sensitivity_list()
  {
@@ -2066,17 +2072,17 @@ QCString sensitivity_clause() :  {QCString s;}
   }
 }
 
-QCString sensitivity_list() :  {QCString s,s1;}
+VhdlString sensitivity_list() :  {VhdlString s,s1;}
 {
  s=name() (<COMMA_T> s1=name(){s+=",";s+=s1;} )* { return s;}
 }
 
-QCString sequence_of_statement() : {QCString s,s1;}
+VhdlString sequence_of_statement() : {VhdlString s,s1;}
 {
  ( LOOKAHEAD(3) s1=sequential_statement() {s+=s1;} )* { return s;}
 }
 
-QCString sequential_statement() :{QCString s;}
+VhdlString sequential_statement() :{VhdlString s;}
 {
     LOOKAHEAD( [ identifier() ":" ] target() "<=")
     s=signal_assignment_statement(){FlowChart::addFlowChart(FlowChart::TEXT_NO,s.data(),0);return s;}
@@ -2117,11 +2123,11 @@ QCString sequential_statement() :{QCString s;}
     s=null_statement(){FlowChart::addFlowChart(FlowChart::TEXT_NO,s.data(),0);return s;}
 }
 
-QCString shift_expression() :  {QCString s,s1,s2;}
+VhdlString shift_expression() :  {VhdlString s,s1,s2;}
 {
  s=simple_expression() [ s1=shift_operator() s2=simple_expression() ] { return s+s1+s2;}
 }
-QCString shift_operator() :  {}
+VhdlString shift_operator() :  {}
 {
   <SLL_T> { return "sll";}
   | <SRL_T> { return "srl";}
@@ -2131,13 +2137,13 @@ QCString shift_operator() :  {}
   | <ROR_T> { return "ror";}
 }
 
-QCString sign() :  {}
+VhdlString sign() :  {}
 {
  <PLUS_T> { return "+";}
  | <MINUS_T> { return "-";}
 }
 
-QCString signal_assignment_statement() : {QCString s,s1,s2,s3;}
+VhdlString signal_assignment_statement() : {VhdlString s,s1,s2,s3;}
 {
 
   LOOKAHEAD(conditional_signal_assignment_wave())
@@ -2161,7 +2167,7 @@ void semi() :  {}
 <SEMI_T>
 }
 
-void signal_declaration() :  { Token* tok=0;QCString s,s1,s2,s3,s4;}
+void signal_declaration() :  { Token* tok=0;VhdlString s,s1,s2,s3,s4;}
 {
 <SIGNAL_T> s=identifier_list() <COLON_T> s1=subtype_indication() [ s2=signal_kind() ] [ tok=<VARASSIGN_T> s3=expression() ] <SEMI_T>
      {
@@ -2171,20 +2177,20 @@ void signal_declaration() :  { Token* tok=0;QCString s,s1,s2,s3,s4;}
      addVhdlType(s.data(),getLine(),Entry::VARIABLE_SEC,VhdlDocGen::SIGNAL,0,s4.data(),Public);
      }
 }
-QCString signal_kind() :  {}
+VhdlString signal_kind() :  {}
 {
   <REGISTER_T> { return "register";}
   | <BUS_T>  { return "bus";}
 }
 
-QCString signal_list() : {QCString s,s1;}
+VhdlString signal_list() : {VhdlString s,s1;}
 {
  s=name() (<COMMA_T>  s1=name() { s+=",";s+=s1;})*
 | <OTHER_T> { return "other";}
 | <ALL_T> { return "all";}
 }
 
-QCString signature() : {QCString s,s1,s2;}
+VhdlString signature() : {VhdlString s,s1,s2;}
 {
 <LBRACKET_T>
  [ s=name()  (<COMMA_T> s1=name() {s+=",";s+=s1; })* ]
@@ -2193,7 +2199,7 @@ QCString signature() : {QCString s,s1,s2;}
   { s1="["+s+"]";return s1;}
  }
 
-QCString simple_expression():  {QCString s,s1,s2;}
+VhdlString simple_expression():  {VhdlString s,s1,s2;}
 {
 [ s=sign() ] s1=term() {s+=s1;} ( LOOKAHEAD(adding_operator() term()) s1=adding_operator() s2=term() {s+=s1;s+=s2;})* { return s;}
 }
@@ -2203,17 +2209,17 @@ void simple_name() :  {}
 name()
 }
 
-QCString slice_name() :  {QCString s,s1;}
+VhdlString slice_name() :  {VhdlString s,s1;}
 {
  s=identifier() <LPAREN_T> s1=discrete_range() <RPAREN_T> {return s+"("+s1+")";}
 }
 
-QCString string_literal() : {Token *tok=0;}
+VhdlString string_literal() : {Token *tok=0;}
 {
 tok=<STRINGLITERAL> {return tok->image.c_str();}
 }
 
- void subprogram_body() : {QCString s;}
+ void subprogram_body() : {VhdlString s;}
 {
 //subprogram_specification()
 <IS_T>
@@ -2222,7 +2228,7 @@ tok=<STRINGLITERAL> {return tok->image.c_str();}
    {
       if (s.data())
       {
-        FlowChart::addFlowChart(FlowChart::VARIABLE_NO,s,0);
+        FlowChart::addFlowChart(FlowChart::VARIABLE_NO,s.data(),0);
       }
       FlowChart::addFlowChart(FlowChart::BEGIN_NO,"BEGIN",0);
     }
@@ -2252,7 +2258,7 @@ void subprogram_1() :  {}
  | <SEMI_T>
 }
 
-QCString subprogram_declarative_item() : {QCString s;}
+VhdlString subprogram_declarative_item() : {VhdlString s;}
 {
 subprogram_declaration(){ return "";}
 |s=type_declaration(){ return s;}
@@ -2273,7 +2279,7 @@ s=group_template_declaration(){ return s;}
 | s=group_declaration() { return s;}
 }
 
-QCString subprogram_declarative_part() : {QCString s,s1;}
+VhdlString subprogram_declarative_part() : {VhdlString s,s1;}
 {
   (s1=subprogram_declarative_item(){s+=s1;})* { return s;}
 }
@@ -2284,7 +2290,7 @@ void subprogram_kind() :  {}
  |<PROCEDURE_T>
 }
 
-void subprogram_specification() : {QCString s;Token *tok=0;Token *t;}
+void subprogram_specification() : {VhdlString s;Token *tok=0;Token *t;}
 {
  <PROCEDURE_T> s=designator()
  {
@@ -2304,7 +2310,7 @@ void subprogram_specification() : {QCString s;Token *tok=0;Token *t;}
   {
      currP=VhdlDocGen::FUNCTION;
      if(tok)
-     createFunction(tok->image.c_str(),currP,s.data());
+     createFunction(tok->image.data(),currP,s.data());
      else
      createFunction(0,currP,s.data());
       tempEntry=current;
@@ -2315,7 +2321,7 @@ void subprogram_specification() : {QCString s;Token *tok=0;Token *t;}
     <RETURN_T> s=type_mark()
              {
                 tempEntry=current;
-                current->type=s;
+                current->type=s.data();
                 newEntry();
               }
 }
@@ -2325,7 +2331,7 @@ void subprogram_statement_part() : {}
   (sequential_statement())*
 }
 
-QCString subtype_declaration() :  {QCString s,s1;}
+VhdlString subtype_declaration() :  {VhdlString s,s1;}
 {
 <SUBTYPE_T> s=identifier() <IS_T> s1=subtype_indication() <SEMI_T>
   {
@@ -2334,14 +2340,14 @@ QCString subtype_declaration() :  {QCString s,s1;}
   }
 }
 
-QCString subtype_indication() :  {QCString s,s1,s2;}
+VhdlString subtype_indication() :  {VhdlString s,s1,s2;}
 {
  s=name()
  [LOOKAHEAD (name()) s1=name()] [LOOKAHEAD(constraint() ) s2=constraint()]
  {return s+" "+s1+" "+s2;}
 }
 
-QCString suffix() :  {QCString s;}
+VhdlString suffix() :  {VhdlString s;}
 {
 LOOKAHEAD(name())
 s=name() { return s;}
@@ -2350,18 +2356,18 @@ s=name() { return s;}
 | <ALL_T> {return " all ";}
 }
 
-QCString target() :  {QCString s;}
+VhdlString target() :  {VhdlString s;}
 {
  s=name(){ return s;}
 | s=aggregate() { return s;}
 }
 
-QCString term() : {QCString s,s1,s2;}
+VhdlString term() : {VhdlString s,s1,s2;}
 {
  s=factor() ( LOOKAHEAD(2) s1=multiplying_operation() s2=factor(){s+=s1;s+=s2;} )* { return s;}
 }
 
-QCString timeout_clause() : {QCString s;}
+VhdlString timeout_clause() : {VhdlString s;}
 {
 <FOR_T>  s=expression()
 {
@@ -2369,19 +2375,19 @@ QCString timeout_clause() : {QCString s;}
 }
 }
 
-QCString type_conversion() : {QCString s,s1;}
+VhdlString type_conversion() : {VhdlString s,s1;}
 {
   s=name() <LPAREN_T> s1=expression() <RPAREN_T> { return s+"("+s1+")";}
 }
 
-QCString type_declaration() : {QCString s;}
+VhdlString type_declaration() : {VhdlString s;}
 {
 LOOKAHEAD(3)
 s=full_type_declaration(){ return s;}
 | s=incomplete_type_declaration(){ return s;}
 }
 
-QCString type_definition() :  {QCString s;}
+VhdlString type_definition() :  {VhdlString s;}
 {
 //try{
 s=scalar_type_definition(){ return s;}
@@ -2395,21 +2401,23 @@ s=scalar_type_definition(){ return s;}
 //}catch(...){error_skipto(SEMI_T); return "";}
 }
 
-QCString type_mark() : {QCString s; }
+VhdlString type_mark() : {VhdlString s; }
 {
   s=name() { return s;}
 }
 
-QCString unconstraint_array_definition() :  {QCString s,s1,s2,s3;}
+VhdlString unconstraint_array_definition() :  {VhdlString s,s1,s2,s3;}
 {
 <ARRAY_T> <LPAREN_T> s=index_subtype_definition() ( <COMMA_T> s1=index_subtype_definition(){s3+=",";s3+=s1;})* <RPAREN_T>
  <OF_T> s2=subtype_indication() {return "array("+s+s3+") of "+s2;}
 }
 
- QCString use_clause() :  {QCString s,s1;}
+ VhdlString use_clause() :  {VhdlString ws,ws1;}
 {
- <USE_T> s=selected_name()(<COMMA_T> s1=selected_name(){s+=",";s+=s1;})*   <SEMI_T>
+ <USE_T> ws=selected_name()(<COMMA_T> ws1=selected_name(){ws+=",";ws+=ws1;})*   <SEMI_T>
   {
+                   QCString s=ws.data();
+                   QCString s1=ws1.data();
                    QStringList ql1=QStringList::split(",",s,FALSE);
                    for (uint j=0;j<ql1.count();j++)
                    {
@@ -2420,12 +2428,14 @@ QCString unconstraint_array_definition() :  {QCString s,s1,s2,s3;}
                        VhdlParser::addVhdlType(it.data(),getLine(),Entry::VARIABLE_SEC,VhdlDocGen::USE,it.data(),"_use_",Public);
                      }
                    }
+                   
                    s1="use "+s;
-                   return s1;
+                   
+                   return VhdlString(s1.data()) ;
    }
 }
 
-QCString variable_assignment_statement() :  {QCString s,s1,s2;}
+VhdlString variable_assignment_statement() :  {VhdlString s,s1,s2;}
 {
 [LOOKAHEAD(2) s=identifier() <COLON_T> {s+=":";}]
  s1=target() <VARASSIGN_T> s2=expression() <SEMI_T>
@@ -2434,7 +2444,7 @@ QCString variable_assignment_statement() :  {QCString s,s1,s2;}
  selected_variable_assignment() { return "";  }
 }
 
-QCString variable_declaration() :  {Token *tok=0;Token *t1=0;QCString s,s1,s2;}
+VhdlString variable_declaration() :  {Token *tok=0;Token *t1=0;VhdlString s,s1,s2;}
 {
 [ tok=<SHARED_T> ] <VARIABLE_T> s=identifier_list() <COLON_T> s1=subtype_indication()
 [ t1=<VARASSIGN_T> s2=expression() ] <SEMI_T>
@@ -2443,8 +2453,8 @@ QCString variable_declaration() :  {Token *tok=0;Token *t1=0;QCString s,s1,s2;}
     int spec;
     if(t1)
      s2.prepend(":=");
-    QCString val=" variable "+s+":"+s1+s2+";";
-    QCString it=s1;
+    VhdlString val=" variable "+s+":"+s1+s2+";";
+    VhdlString it=s1;
     if(tok != 0)
     {
      it.prepend(" shared ");
@@ -2464,7 +2474,7 @@ QCString variable_declaration() :  {Token *tok=0;Token *t1=0;QCString s,s1,s2;}
 
 }
 
-QCString wait_statement() :  {QCString s,s1,s2,s3;Token *t=0;}
+VhdlString wait_statement() :  {VhdlString s,s1,s2,s3;Token *t=0;}
 {
 [ s=identifier() t=<COLON_T> ] <WAIT_T> [ s1=sensitivity_clause() ] [ s2=condition_clause() ] [ s3=timeout_clause() ] <SEMI_T>
 {
@@ -2473,7 +2483,7 @@ QCString wait_statement() :  {QCString s,s1,s2,s3;Token *t=0;}
 }
 }
 
-QCString waveform() :  {QCString s,s1;}
+VhdlString waveform() :  {VhdlString s,s1;}
 {
 s=waveform_element() (LOOKAHEAD(1) <COMMA_T> s1=waveform_element(){s+=","; s+=s1;})* { return s;}
 |
@@ -2481,7 +2491,7 @@ s=waveform_element() (LOOKAHEAD(1) <COMMA_T> s1=waveform_element(){s+=","; s+=s1
 
 }
 
-QCString waveform_element() :  {QCString s,s1;}
+VhdlString waveform_element() :  {VhdlString s,s1;}
 {
  s=expression() [ <AFTER_T> s1=expression(){ s1.prepend(" after ");} ]
  { return s+s1;}
@@ -2492,7 +2502,7 @@ QCString waveform_element() :  {QCString s,s1;}
 // VHDL 2002
 // -----------------------------------------------------------------
 
-QCString protected_type_body() :{ }
+VhdlString protected_type_body() :{ }
 {
   // try{
    <PROTECTED_T> <BODY_T>
@@ -2529,7 +2539,7 @@ void protected_type_body_declarative_part() :{  }
 }
 
 
-QCString protected_type_declaration() : {  }
+VhdlString protected_type_declaration() : {  }
  {
    <PROTECTED_T>
         try{
@@ -2555,7 +2565,7 @@ void protected_type_declarative_part() :    {}
 // VHDL 2008
 // -----------------------------------------------------------------
 
-QCString context_ref() : {QCString s;}
+VhdlString context_ref() : {VhdlString s;}
 {
  <CONTEXT_T>  s=identifier_list() <SEMI_T>
  {
@@ -2563,7 +2573,7 @@ QCString context_ref() : {QCString s;}
  }
 }
 
-void context_declaration(): {QCString s,s1;}
+void context_declaration(): {VhdlString s,s1;}
 {
  <CONTEXT_T> s=identifier() <IS_T> { parse_sec=CONTEXT_SEC; }  (s1=libustcont_stats())* <END_T> [ <CONTEXT_T> ][identifier()] <SEMI_T>
                         {
@@ -2572,36 +2582,36 @@ void context_declaration(): {QCString s,s1;}
                         }
 }
 
-QCString libustcont_stats(): {QCString s;}
+VhdlString libustcont_stats(): {VhdlString s;}
 {
    s=use_clause()  { return s;}
    | s=library_clause() { return s;}
    | s=context_ref() { return s;}
 }
 
- void package_instantiation_declaration() : {QCString s,s1,s2;}
+ void package_instantiation_declaration() : {VhdlString s,s1,s2;}
  {
  <PACKAGE_T> s=identifier() <IS_T>  <NEW_T> s1=name() s2=signature() [gen_assoc_list()] <SEMI_T>
     {
-      QCString q=" is new "+s1+s2;
+      VhdlString q=" is new "+s1+s2;
       addVhdlType(s.data(),getLine(PACKAGE_T),Entry::VARIABLE_SEC,VhdlDocGen::INSTANTIATION,"package",q.data(),Public);
     }
 }
 
-QCString interface_package_declaration(): {QCString s,s1;}
+VhdlString interface_package_declaration(): {VhdlString s,s1;}
 {
  <PACKAGE_T> s=identifier() <IS_T> <NEW_T> s1=name() [gen_assoc_list()]
                         {
-                          current->name=s;
+                          current->name=s.data();
                             return "package "+s+" is new "+s1;
                          }
 }
 
-QCString subprogram_instantiation_declaration():{QCString s,s1,s2;}
+VhdlString subprogram_instantiation_declaration():{VhdlString s,s1,s2;}
 {
  <FUNCTION_T>  s=identifier() <IS_T> <NEW_T> s1=name()  s2=signature() [gen_assoc_list()] <SEMI_T>
     {
-     QCString q= " is new "+s1+s2;
+     VhdlString q= " is new "+s1+s2;
       addVhdlType(s.data(),getLine(FUNCTION_T),Entry::VARIABLE_SEC,VhdlDocGen::INSTANTIATION,"function ",q.data(),Public);
     return q;
     }
@@ -2622,7 +2632,7 @@ void gen_interface_list() : {}
                         }
                         interface_list()
                         {
-                        //  QCString vo=$3;
+                        //  VhdlString vo=$3;
                           parse_sec=0;
                         }
                         <RPAREN_T>
@@ -2660,17 +2670,17 @@ void generate_statement_body1() : {}
   // | (concurrent_statement())*
 }
 
-QCString external_name(): {QCString s,s1,s2;}
+VhdlString external_name(): {VhdlString s,s1,s2;}
 {
  <SLSL_T> s=sig_stat() s1=external_pathname() <COLON_T>  s2=subtype_indication()  <RSRS_T>
                         {
-                         QCString t="<<"+s;
-                         QCString t1=s1+":"+s2+">>";
+                         VhdlString t="<<"+s;
+                         VhdlString t1=s1+":"+s2+">>";
                          return   s+s1;
                         }
 }
 
-QCString sig_stat(): {Token *t;}
+VhdlString sig_stat(): {Token *t;}
 {
   t=<CONSTANT_T>      { return t->image.data(); }
   | t=<SIGNAL_T>      { return t->image.data(); }
@@ -2678,31 +2688,31 @@ QCString sig_stat(): {Token *t;}
 
 }
 
-QCString external_pathname(): {QCString s;}
+VhdlString external_pathname(): {VhdlString s;}
 {
    s=absolute_pathname()  { return s;}
  | s=relative_pathname()   { return s;}
  | s=package_path_name()   { return s;}
  }
 
-QCString absolute_pathname(): {QCString s,s1;}
+VhdlString absolute_pathname(): {VhdlString s,s1;}
 {
  LOOKAHEAD(<DOT_T>  pathname_element_list())
  <DOT_T>  s=pathname_element_list() s1=identifier() { return "."+s+s1;}
 | <DOT_T>  s=identifier (){ return "."+s;}
 }
 
-QCString relative_pathname():{QCString s,s1,s2;}
+VhdlString relative_pathname():{VhdlString s,s1,s2;}
 {
   s=neg_list() [LOOKAHEAD( pathname_element_list()) s1=pathname_element_list() ] s2=identifier() { return s+s1+s2;}
 }
 
-QCString neg_list(): {QCString s;}
+VhdlString neg_list(): {VhdlString s;}
 {
  (<NEG_T> <DOT_T>{s+="^.";})+     {return s; }
 }
 
-QCString pathname_element ():{QCString s,s1;}
+VhdlString pathname_element ():{VhdlString s,s1;}
 {
   s=identifier() [<LPAREN_T> s1=expression()  <RPAREN_T>]
   {
@@ -2713,13 +2723,13 @@ QCString pathname_element ():{QCString s,s1;}
   }
  }
 
-QCString pathname_element_list():{QCString s,s1,s2;}
+VhdlString pathname_element_list():{VhdlString s,s1,s2;}
 {
         ( s=pathname_element() <DOT_T> ) {s+=".";} (LOOKAHEAD(pathname_element() <DOT_T>) s1=pathname_element() <DOT_T> {s2+=s1;s2+="."; })*
         { return s+s2; }
 }
 
-QCString package_path_name():{QCString s;}
+VhdlString package_path_name():{VhdlString s;}
 {
  <AT_T> s=name() { return "@"+s; }
 }
@@ -2804,37 +2814,37 @@ void else_stat(): {}
 
 
 
-QCString interface_subprogram_declaration(): {QCString s;}
+VhdlString interface_subprogram_declaration(): {VhdlString s;}
 {
   s=iproc()  { return s;}
  | s=ifunc()  { return s; }
 }
 
-QCString iproc(): {QCString s,s1;}
+VhdlString iproc(): {VhdlString s,s1;}
  {
   <PROCEDURE_T> s=identifier()  s1=param()
   {
-  current->name=s;
+  current->name=s.data();
   return "procedure "+s+s1;
   }
  }
 
-QCString ifunc():{QCString s,s1,s2,s3;Token *t=0;Token *t1=0;Token *t2=0;}
+VhdlString ifunc():{VhdlString s,s1,s2,s3;Token *t=0;Token *t1=0;Token *t2=0;}
 {
 
  [t=<PURE_T> | t=<IMPURE_T> ] <FUNCTION_T>  s=name() s1=param() <RETURN_T> s2=name() [t1=<IS_T> (s3=identifier() | t2=<BOX_T>)]
     {
-      QCString q;
+      VhdlString q;
       if(t) q=t->image.data();
       if(t2) s3="<>";
       if (!s3.isEmpty())
       {
         s3.prepend(" is ");
       }
-     current->name=s;
+     current->name=s.data();
     if (parse_sec==GEN_SEC)
                     {
-                      QCString ss=q+" function "+s1+" return "+s2+s3;
+                      VhdlString ss=q+" function "+s1+" return "+s2+s3;
                       int a=getLine(FUNCTION_T);
                       int b=getLine(PROCEDURE_T);
 
@@ -2847,7 +2857,7 @@ QCString ifunc():{QCString s,s1,s2,s3;Token *t=0;Token *t1=0;Token *t2=0;}
     }
 
 
-QCString param(): {QCString s,s1;Token *tok=0;}
+VhdlString param(): {VhdlString s,s1;Token *tok=0;}
 {
 [ tok=<PARAMETER_T> ] { param_sec=PARAM_SEC; }
                   [ <LPAREN_T>  s1=interface_list() <RPAREN_T>]
